/*calc-curve.js, aizo gmbh, ct
TODO: cal2 und offset2 sauber berechnen fr curvetype 0
TODO: Phasenanschnittsdimmer

v0.0.3, 06.12.2012
 - curvetype wird jetzt beruecksichtigt
 - firmware_version wird jetzt benutzt um zu entscheiden, ob ein oder zwei Stze Kalibrierwerte geschrieben werden mssen
 - Debugs aufgerumt
v0.0.2, 04.12.2012
 - Maximalwert gefixt (es wurde vorher immer 10000 gepusht, jetzt der letzte Wert)
v0.0.1, 30.11.2012
*/

function Debug(){}


function getLuxVal(curve, outval) {
   var lasti = 0;
   for (var i in curve) {
      if (i>outval) {
         return ((curve[i]-curve[lasti])/(i-lasti)*(outval-lasti))+curve[lasti];
      }
      lasti = i;
   }
}

function getOutVal(curve, lux) {
   for (var i=0; i<256; i++) {
      if (getLuxVal(curve, i)>=lux) {
         var check1 = lux-getLuxVal(curve, i-1);
         var check2 = getLuxVal(curve, i)-lux;
         if (check1<check2) {
            return (i-1);
         } else {
            return i;
         }
      }
   }
   return 255;
}

function getLuxEmpfindung(curve2, outval) {
   var empf_min = 0.21 * Math.pow(getLuxVal(curve2, 16), 0.33);
   var empf_max = 0.21 * Math.pow(getLuxVal(curve2, 255), 0.33);

   if (outval == 0) {
      return 0;
   }

   return Math.pow(((empf_min + ( (empf_max-empf_min)/239 * (outval-16) )  ) / 0.21),1/0.33);
}

//curvetype: Kurventyp
//  0 = Berechnete Kurve
//  1 = Werkseinstellung
//  2 = linear 0..100%
//  3 = linear zwischen den Rckkanalfenstern
//rawcurve: Rohwerte als benanntest Array (pos = OUTVAL 0..255, value = Messwert 0..9999) Aufsteigend nach pos sortiert
//dimmbar_ab: OUTVAL ab dem das Leuchtmittel sinnvoll dimmbar ist
//device: 16 Bit Product ID
//firmware_version: 16 Bit Firmware Version
//lz   true= false=
//AnAb 0=Ab 1=An
function doCalcCurve(curvetype, rawcurve, dimmbar_ab, device, firmware_version, lz, AnAb) {
   var mode;
   var kl = new Array();
   var cal1;
   var cal2;
   var offset1;
   var offset2;
   var thr1 = 16;
   var thr2 = 16;
   var hwlen1 = 2500;
   var hwlen2 = 2500;

                  Debug('doCalcCurve: curvetype        = '+curvetype);
                  Debug('doCalcCurve: rawcurve         = '+rawcurve);
                  Debug('doCalcCurve: dimmbar_ab       = '+dimmbar_ab);
                  Debug('doCalcCurve: device           = 0x'+device.toString(16));
                  Debug('doCalcCurve: firmware_version = 0x'+firmware_version.toString(16));
                  Debug('doCalcCurve: lz               = '+lz);
                  Debug('doCalcCurve: AnAb             = '+AnAb);
                  Debug('');

   if        (AnAb == 0) {
      mode = 22; //Phasenabschnittsdimmer mit Kennlinie
   } else if (AnAb == 1) {
      mode = 20; //Phasenanschnittsdimmer mit Kennlinie
   } else {
      mode = 16; //Schalter
   }
                  Debug('doCalcCurve: mode = '+mode);
                  Debug('');

   if        (curvetype == 0) { //Berechnete Kurve
      var curve = new Array();
      var curve2 = new Array();

      rawcurve.push({pos:256, value:rawcurve[rawcurve.length-1].value});

      //rawcurve interpolieren
      var rawcurve2 = new Array();
      var pos1 = 0;
      var pos2 = 0;
      for (i = 0; i < 256; i++) {
         for (pos1 in rawcurve) {
            if (rawcurve[pos1].pos > i) {
               rawcurve2[i] = ((rawcurve[pos2].value-rawcurve[pos1].value)/(rawcurve[pos2].pos-rawcurve[pos1].pos)*(i-rawcurve[pos1].pos))+rawcurve[pos1].value;
               break;
             }
            pos2 = pos1;
         }
      }
      rawcurve2[256] = rawcurve2[255];

                  //for (i in rawcurve2) {
                  //   Debug('rawcurve2['+i+'] = '+rawcurve2[i]);
                  //}
                  //Debug('');
                  //Debug('');

      //Offset umrechnen. KM hat angenommene HW-Schaltverzgerung: 0,424ms (OFFSET 720 default), SDS hat 1,26ms Schaltverzgerung im Mittel (OFFSET 511 default)
      //Hier werden die Messwerte verschoben
      var verschiebung = 0;
      if (device>>10 == 6) { //SDS
         verschiebung = -21;
      }

                  Debug('doCalcCurve: verschiebung = '+verschiebung);
                  Debug('');

      var last;
      for (i = 0; i < 256; i++) {
         if ( ((i+verschiebung)>=0)  && ((i+verschiebung) < 256) )   {
                        //Debug ('doCalcCurve: curve['+(i+verschiebung)+'] = '+rawcurve2[i]);
            curve[i+verschiebung] = rawcurve2[i];
            last = rawcurve2[i];
         }
      }

      curve[0] = rawcurve2[0];
      curve[256] = curve[255] = last;

      //dimmbar_ab umrechnen
      dimmbar_ab += verschiebung;
      if (dimmbar_ab < 0) {
         dimmbar_ab = 0;
      }


                  //for (i in curve) {
                  //   Debug ('doCalcCurve: curve['+i+'] = '+curve[i]);
                  //}

                  Debug ('doCalcCurve: dimmbar_ab = '+dimmbar_ab);
                  Debug('');


      //min berechnen
      min = 0;
      for (i in curve) {
         if (curve[i] != 0) {
            min = i;
            break;
         }
      }
      if (dimmbar_ab > min) min = dimmbar_ab;
                  Debug ('doCalcCurve: min = '+min);
                  Debug('');

      //max berechnen
      max = 0;
      maxval = 0;
      for (i in curve) {
         if (curve[i] > maxval){
            max = i;
            maxval = curve[i];
         }
      }

   //   if ((max - verschiebung) > 255) max = max+verschiebung;
   //               Debug ('max = '+max);

      //Mgliches min vor dem Threshold errechnen
      var mincalc = min-((max-min)/239*16);
      if (mincalc<0) {
         //!-- TODO Threshold runtersetzen
         mincalc=0;
      }

      //Dimmerbereich berechnen
      var offset1 = Math.round(mincalc*257*2500/65536);
      var offset2 = offset1;

      var cal1 = Math.round(((max-(65536/(257*2500)*offset1))*(257/255))-2);
      var cal2 = cal1;

                  Debug('doCalcCurve: mincalc = '+mincalc);
                  Debug('');


      //Kennlinie berechnen
      for (var i=0; i<256; i++) {
         curve2[i] = getLuxVal(curve, (i*(cal1+2)/257) + (65536/(257*2500)*offset1) );
      }
      curve2[0] = 0;
      curve2[256] = curve2[255];

                  Debug('');
                  for (var i=0; i<257; i+=16) {
                     if (i==256) i=255;
                     Debug('doCalcCurve: data '+Math.round(i/16)+' = '+getOutVal(curve2, getLuxEmpfindung(curve2, i)));
                  }
                  Debug('');

                  // Lux nach Empfindung:
                  for (var i=0; i<257; i+=16) {
                     if (i==256) i=255;
                     var val = Math.round(getLuxVal(curve2, getOutVal(curve2, getLuxEmpfindung(curve2, i))));
                     Debug('doCalcCurve: lux '+Math.round(i/16)+' = '+val);
                     if (i==16) {
                        minlux = val;
                     }
                     if (i==255) {
                        maxlux = val;
                     }
                  }
                  Debug('');

                  var prozent_von = Math.round(minlux*100/curve[max]);
                  var prozent_bis = Math.round(maxlux*100/curve[max]);
                  Debug('doCalcCurve: In Prozent: '+prozent_von+'..'+prozent_bis+'%');
                  Debug('');

   /*
                  glob_graph_x = new Array();
                  glob_graph_y = new Array();

                  glob_graph_y[0] = new Array();

                  //blau Messkurve
                  for (var i=0; i<32; i++) {
                     glob_graph_x[i] = i*8;
                     glob_graph_y[0][i] = getLuxVal(curve, i*8);
                  }
                  glob_graph_x[32] = 255;
                  glob_graph_y[0][32] = getLuxVal(curve, 255);

                  //grn Lux mit Kennline im eingegrenzten Bereich
                  glob_graph_y[1] = new Array();
                  for (var i=0; i<32; i++) {
                     glob_graph_y[1][i] = Math.round(getLuxVal(curve2, getOutVal(curve2, getLuxEmpfindung(curve2, i*8))));
                  }
                  glob_graph_y[1][32] = Math.round(getLuxVal(curve2, getOutVal(curve2, getLuxEmpfindung(curve2, 255))));

                  //rot Messkurve im eingegrenzten Bereich
                  glob_graph_y[2] = new Array();
                  for (var i=0; i<32; i++) {
                     glob_graph_y[2][i] = getLuxVal(curve2, i*8);
                  }
                  glob_graph_y[2][32] = getLuxVal(curve2, 255);

                  doGraph();
                  Debug('');
                  Debug('');
   */
      //Kennlinie zusammenbauen
      kl[ 0] = getOutVal(curve2, getLuxEmpfindung(curve2,   0));
      kl[ 1] = getOutVal(curve2, getLuxEmpfindung(curve2,  16));
      kl[ 2] = getOutVal(curve2, getLuxEmpfindung(curve2,  32));
      kl[ 3] = getOutVal(curve2, getLuxEmpfindung(curve2,  48));
      kl[ 4] = getOutVal(curve2, getLuxEmpfindung(curve2,  64));
      kl[ 5] = getOutVal(curve2, getLuxEmpfindung(curve2,  80));
      kl[ 6] = getOutVal(curve2, getLuxEmpfindung(curve2,  96));
      kl[ 7] = getOutVal(curve2, getLuxEmpfindung(curve2, 112));
      kl[ 8] = getOutVal(curve2, getLuxEmpfindung(curve2, 128));
      kl[ 9] = getOutVal(curve2, getLuxEmpfindung(curve2, 144));
      kl[10] = getOutVal(curve2, getLuxEmpfindung(curve2, 160));
      kl[11] = getOutVal(curve2, getLuxEmpfindung(curve2, 176));
      kl[12] = getOutVal(curve2, getLuxEmpfindung(curve2, 192));
      kl[13] = getOutVal(curve2, getLuxEmpfindung(curve2, 208));
      kl[14] = getOutVal(curve2, getLuxEmpfindung(curve2, 224));
      kl[15] = getOutVal(curve2, getLuxEmpfindung(curve2, 240));
      kl[16] = getOutVal(curve2, getLuxEmpfindung(curve2, 255));

   } else if (curvetype == 1) { //Kurve in den RK Fenstern (Werkseinstellung)
      kl[ 0] =   0  ;
      kl[ 1] =  16 ;
      kl[ 2] =  34 ;
      kl[ 3] =  52 ;
      kl[ 4] =  68 ;
      kl[ 5] =  84 ;
      kl[ 6] =  99 ;
      kl[ 7] = 114;
      kl[ 8] = 128;
      kl[ 9] = 142;
      kl[10] = 157;
      kl[11] = 171;
      kl[12] = 186;
      kl[13] = 202;
      kl[14] = 219;
      kl[15] = 237;
      kl[16] = 255;

      if (device>>10 == 6) { //SDS
         cal1 = 89;
         cal2 = 66;
         offset1 = 511;
         offset2 = 642
      } else { //KM, SDM
         cal1 = 89;
         cal2 = 66;
         offset1 = 720;
         offset2 = 851;
      }

   } else if (curvetype == 2) { //Lineare Kurve ohne RK fenster
      kl[ 0] =   0;
      kl[ 1] =  15;
      kl[ 2] =  31;
      kl[ 3] =  47;
      kl[ 4] =  63;
      kl[ 5] =  79;
      kl[ 6] =  95;
      kl[ 7] = 111;
      kl[ 8] = 127;
      kl[ 9] = 143;
      kl[10] = 159;
      kl[11] = 175;
      kl[12] = 191;
      kl[13] = 207;
      kl[14] = 223;
      kl[15] = 239;
      kl[16] = 255;

      if (device>>10 == 6) { //SDS
         cal1 = 226; //max 10,13ms
         cal2 = 226; //max 10,13ms
         offset1 = 0;
         offset2 = 0;
      } else { //KM, SDM
         cal1 = 247; //max 10,11ms
         cal2 = 247; //max 10,11ms
         offset1 = 0;
         offset2 = 0;
      }

   } else if (curvetype == 3) { //Lineare Kurve in den RK Fenstern
      kl[ 0] =   0;
      kl[ 1] =  15;
      kl[ 2] =  31;
      kl[ 3] =  47;
      kl[ 4] =  63;
      kl[ 5] =  79;
      kl[ 6] =  95;
      kl[ 7] = 111;
      kl[ 8] = 127;
      kl[ 9] = 143;
      kl[10] = 159;
      kl[11] = 175;
      kl[12] = 191;
      kl[13] = 207;
      kl[14] = 223;
      kl[15] = 239;
      kl[16] = 255;

      if (device>>10 == 6) { //SDS
         cal1 = 89;
         cal2 = 66;
         offset1 = 511;
         offset2 = 642
      } else { //KM, SDM
         cal1 = 89;
         cal2 = 66;
         offset1 = 720;
         offset2 = 851;
      }

   } else {
                  Debug('doCalcCurve: Unbekannter curvetype: '+curvetype);
                  Debug('');
      return [];
   }


                  Debug('doCalcCurve: cal1 = '+cal1);
                  Debug('doCalcCurve: cal2 = '+cal2);
                  Debug('doCalcCurve: offset1 = '+offset1);
                  Debug('doCalcCurve: offset2 = '+offset2);
                  Debug('');

               //Offset umrechnen. KM hat angenommene HW-Schaltverzgerung: 0,424ms (720 default), SDS hat 1,26ms Schaltverzgerung im Mittel (511 default)
               var caloffset = 0.424;
               if (device>>10 == 6) { //SDS
                  caloffset = 1.26;
               }
               //!-- Hier mnuss noch die Kennlinie eingerechnet werden
               var start = ((((cal1+2)*thr1*hwlen1)/65536)+offset1)/250 + caloffset;
               var end   = ((((cal1+2)*255*hwlen1)/65536)+offset1)/250 + caloffset;
               Debug('doCalcCurve: Dimmbereich = '+start+'ms..'+end+'ms');
               Debug('');

      //Rckgabearray zusammenbauen
   if ( ((firmware_version >= 0xb000) && (firmware_version < 0xb029)) || //Ein Satz Parameter
        (firmware_version < 0x0350)
      ) {
      return [{bank:3, offset:0x00, value:mode},               //MODE
              {bank:3, offset:0x30, value:kl[ 0]},             //KL[ 0]
              {bank:3, offset:0x31, value:kl[ 1]},             //KL[ 1]
              {bank:3, offset:0x32, value:kl[ 2]},             //KL[ 2]
              {bank:3, offset:0x33, value:kl[ 3]},             //KL[ 3]
              {bank:3, offset:0x34, value:kl[ 4]},             //KL[ 4]
              {bank:3, offset:0x35, value:kl[ 5]},             //KL[ 5]
              {bank:3, offset:0x36, value:kl[ 6]},             //KL[ 6]
              {bank:3, offset:0x37, value:kl[ 7]},             //KL[ 7]
              {bank:3, offset:0x38, value:kl[ 8]},             //KL[ 8]
              {bank:3, offset:0x39, value:kl[ 9]},             //KL[ 9]
              {bank:3, offset:0x3A, value:kl[10]},             //KL[10]
              {bank:3, offset:0x3B, value:kl[11]},             //KL[11]
              {bank:3, offset:0x3C, value:kl[12]},             //KL[12]
              {bank:3, offset:0x3D, value:kl[13]},             //KL[13]
              {bank:3, offset:0x3E, value:kl[14]},             //KL[14]
              {bank:3, offset:0x3F, value:kl[15]},             //KL[15]
              {bank:3, offset:0x40, value:kl[16]},             //KL[16]
              //{bank:4, offset:0x28, value:thr1},               //PHASEAB_THR1
              {bank:4, offset:0x29, value:cal1},               //PHASEAB_CAL1
              //{bank:4, offset:0x2A, value: hwlen1&0xff},       //PHASEAB_HWLEN1_LO
              //{bank:4, offset:0x2B, value:(hwlen1>>8)&0xff},   //PHASEAB_HWLEN1_HI
              {bank:4, offset:0x2C, value: offset1&0xff},      //PHASEAB_OFFSET1_LO
              {bank:4, offset:0x2D, value:(offset1>>8)&0xff},  //PHASEAB_OFFSET1_HI
              //{bank:4, offset:0x2E, value:thr2},               //PHASEAB_THR2
              //{bank:4, offset:0x2F, value:cal2},               //PHASEAB_CAL2
              //{bank:4, offset:0x30, value: hwlen2&0xff},       //PHASEAB_HWLEN2_LO
              //{bank:4, offset:0x31, value:(hwlen2>>8)&0xff},   //PHASEAB_HWLEN2_HI
              //{bank:4, offset:0x32, value: offset2&0xff},      //PHASEAB_OFFSET2_LO
              //{bank:4, offset:0x33, value:(offset2>>8)&0xff}   //PHASEAB_OFFSET2_HI
              ];
   } else { //Zwei Stze Parameter
      return [{bank:3, offset:0x00, value:mode},               //MODE
              {bank:3, offset:0x30, value:kl[ 0]},             //KL[ 0]
              {bank:3, offset:0x31, value:kl[ 1]},             //KL[ 1]
              {bank:3, offset:0x32, value:kl[ 2]},             //KL[ 2]
              {bank:3, offset:0x33, value:kl[ 3]},             //KL[ 3]
              {bank:3, offset:0x34, value:kl[ 4]},             //KL[ 4]
              {bank:3, offset:0x35, value:kl[ 5]},             //KL[ 5]
              {bank:3, offset:0x36, value:kl[ 6]},             //KL[ 6]
              {bank:3, offset:0x37, value:kl[ 7]},             //KL[ 7]
              {bank:3, offset:0x38, value:kl[ 8]},             //KL[ 8]
              {bank:3, offset:0x39, value:kl[ 9]},             //KL[ 9]
              {bank:3, offset:0x3A, value:kl[10]},             //KL[10]
              {bank:3, offset:0x3B, value:kl[11]},             //KL[11]
              {bank:3, offset:0x3C, value:kl[12]},             //KL[12]
              {bank:3, offset:0x3D, value:kl[13]},             //KL[13]
              {bank:3, offset:0x3E, value:kl[14]},             //KL[14]
              {bank:3, offset:0x3F, value:kl[15]},             //KL[15]
              {bank:3, offset:0x40, value:kl[16]},             //KL[16]
              //{bank:4, offset:0x28, value:thr1},               //PHASEAB_THR1
              {bank:4, offset:0x29, value:cal1},               //PHASEAB_CAL1
              //{bank:4, offset:0x2A, value: hwlen1&0xff},       //PHASEAB_HWLEN1_LO
              //{bank:4, offset:0x2B, value:(hwlen1>>8)&0xff},   //PHASEAB_HWLEN1_HI
              {bank:4, offset:0x2C, value: offset1&0xff},      //PHASEAB_OFFSET1_LO
              {bank:4, offset:0x2D, value:(offset1>>8)&0xff},  //PHASEAB_OFFSET1_HI
              //{bank:4, offset:0x2E, value:thr2},               //PHASEAB_THR2
              {bank:4, offset:0x2F, value:cal2},               //PHASEAB_CAL2
              //{bank:4, offset:0x30, value: hwlen2&0xff},       //PHASEAB_HWLEN2_LO
              //{bank:4, offset:0x31, value:(hwlen2>>8)&0xff},   //PHASEAB_HWLEN2_HI
              {bank:4, offset:0x32, value: offset2&0xff},      //PHASEAB_OFFSET2_LO
              {bank:4, offset:0x33, value:(offset2>>8)&0xff}]; //PHASEAB_OFFSET2_HI
   }
}